﻿////Grading ID: S6945
//Program: Program 3
//Due Date: 4/1/2020
//CIS 199-75
//Spring 2020
// Description: The program will match tax rate based on income ammount for baseline and candidate 2



using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Prog3
{
    public partial class Prog3Form : Form
    {
        public Prog3Form()
        {
            InitializeComponent();
        }

        // User has clicked the Calculate Tax button
        // Will calculate and display their marginal tax rate
        private void calcTaxBtn_Click(object sender, EventArgs e)
        {
            // The marginal tax rates
            // Baseline
            const decimal BASE_RATE1 = .10m; // 1st tax rate (LOWEST)
            const decimal BASE_RATE2 = .12m; // 2nd tax rate
            const decimal BASE_RATE3 = .22m; // 3rd tax rate
            const decimal BASE_RATE4 = .24m; // 4th tax rate
            const decimal BASE_RATE5 = .32m; // 5th tax rate
            const decimal BASE_RATE6 = .35m; // 6th tax rate
            const decimal BASE_RATE7 = .37m; // 7th tax rate (HIGHEST)

            // Candidate 2
            const decimal C2_RATE1 = .10m;  // 1st tax rate (LOWEST)
            const decimal C2_RATE2 = .12m;  // 2nd tax rate
            const decimal C2_RATE3 = .22m;  // 3rd tax rate
            const decimal C2_RATE4 = .24m;  // 4th tax rate
            const decimal C2_RATE5 = .32m;  // 5th tax rate
            const decimal C2_RATE6 = .35m;  // 6th tax rate
            const decimal C2_RATE7 = .40m;  // 7th tax rate
            const decimal C2_RATE8 = .45m;  // 8th tax rate
            const decimal C2_RATE9 = .50m;  // 9th tax rate
            const decimal C2_RATE10 = .52m; // 10th tax rate (HIGHEST)

            // Taxable income thresholds for each candidate
            // Baseline
            const int BASE_THRESH1 = 9_701;   // 1st baseline threshold (LOWEST)
            const int BASE_THRESH2 = 39_476;  // 2nd baseline threshold
            const int BASE_THRESH3 = 84_201;  // 3rd baseline threshold
            const int BASE_THRESH4 = 160_726; // 4th baseline threshold
            const int BASE_THRESH5 = 204_101; // 5th baseline threshold
            const int BASE_THRESH6 = 510_301; // 6th baseline threshold (HIGHEST)
            const int BASE_STRT_THRESH = 0; // Baseline Starting Threshold

            // Candidate 2
            const int C2_THRESH1 = 9_526;     // 1st threshold (LOWEST)
            const int C2_THRESH2 = 38_701;    // 2nd threshold
            const int C2_THRESH3 = 82_501;    // 3rd threshold
            const int C2_THRESH4 = 157_501;   // 4th threshold
            const int C2_THRESH5 = 200_001;   // 5th threshold
            const int C2_THRESH6 = 250_001;   // 6th threshold
            const int C2_THRESH7 = 500_001;   // 7th threshold
            const int C2_THRESH8 = 2_000_001;  // 8th threshold
            const int C2_THRESH9 = 10_000_001; // 9th threshold (HIGHEST)
            const int C2_STRT_THRESH = 0; // Candidate 2 Starting Threshold

            //baseline arrays
            decimal[] base_Rates = { BASE_RATE1, BASE_RATE2, BASE_RATE3, BASE_RATE4, BASE_RATE5, BASE_RATE6, BASE_RATE7 };
            int[] base_Thresh = { BASE_STRT_THRESH, BASE_THRESH1, BASE_THRESH2, BASE_THRESH3,BASE_THRESH4, BASE_THRESH5, BASE_THRESH6 };

            // Candidate 2 arrays
            decimal[] c2_Rates = { C2_RATE1, C2_RATE2, C2_RATE3, C2_RATE4, C2_RATE5, C2_RATE6, C2_RATE7, C2_RATE8, C2_RATE9, C2_RATE10 };
            int[] c2_Thresh = { C2_STRT_THRESH, C2_THRESH1, C2_THRESH2, C2_THRESH3,C2_THRESH4, C2_THRESH5, C2_THRESH6, C2_THRESH7,C2_THRESH8, C2_THRESH9 };

            //standards to help find out percentage
            decimal percentage = 0;//sets percentage level for output percent text box
            bool found = false;//sentinal value to help break out of a loop once its' conditions are met.
            int income; //is the output of the user's input that will be used to match thresholds

            
            if (int.TryParse(incomeTxt.Text, out income) && income >= 0)
            {
                if (baselineRdoBtn.Checked) // Baseline Button Clicked
                {
                    int base_Index = base_Thresh.Length - 1;

                    while (!found)
                    {

                        if (income >= base_Thresh[base_Index])
                        {

                            found = true;

                            percentage = base_Rates[base_Index];
                        }
                        else
                        --base_Index;
                    }
                }

                if (candidate2RdoBtn.Checked) // Candidate 2 Button Clicked
                {
                    int c2_Index = c2_Thresh.Length - 1;
                    
                    while (!found)
                    {

                        if (income >= c2_Thresh[c2_Index])
                        {

                            found = true;

                            percentage = c2_Rates[c2_Index];
                        }
                        else
                            --c2_Index;
                    }
                }

                // Output results
                marginalRateOutLbl.Text = $"{percentage:P1}";
            }
            else // Invalid input
                MessageBox.Show("Enter valid income!");
        }
    }
}

